/*
 *	dat.c
 *
 *	datt@C̓[`
 *
 *	* Dec Fri 13 21:16:00 JST 2002 Naoyuki Sawa
 *	- 1st [XB
 *	* Dec Sun 15 07:02:00 JST 2002 Naoyuki Sawa
 *	- ZIPkꂽDATt@CɑΉB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

static void
trim_left(char* str)
{
	int len = strlen(str);
	while(isspace(str[0])) {
		memmove(str, str + 1, len--/*I[ƈړ̂ŁA|XgfNg*/);
	}
}

static void
trim_right(char* str)
{
	int len = strlen(str);
	while(isspace(str[len - 1])) {
		str[--len] = '\0';
	}
}

static void
trim(char* str)
{
	trim_left(str);
	trim_right(str);
}

/****************************************************************************
 *	dat
 ****************************************************************************/

static void
dat_seek(DAT* dat, int ofs)
{
	int pos, len;

	/* ʏt@C̏ꍇ... */
	if(dat->zip == 0) {
		fseek(dat->file.fp, ofs, SEEK_SET);

	/* ZIPt@C̏ꍇ... */
	} else {
		/* ݈ʒu擾B */
		pos = unztell(dat->file.uf);
		if(pos < 0) DIE();
		if(pos != ofs) {
			hour_glass(0); /* v\Jn */
			/* wʒu𒴂ĂAJĐ擪ɖ߂B */
			if(pos > ofs) {
				unzCloseCurrentFile(dat->file.uf);
				if(unzOpenCurrentFile(dat->file.uf) != 0) DIE();
				pos = 0;
			}
			/* wʒu܂ŋǂ݁B */
			while(pos < ofs) {
				hour_glass(1); /* vAj[V */
				len = ofs - pos;
				if(len > sizeof _def_vbuff) len = sizeof _def_vbuff;
				if(unzReadCurrentFile(dat->file.uf, _def_vbuff, len) != len) DIE();
				pos += len;
			}
			hour_glass(2); /* v\I */
		}
	}
}

static int
dat_tell(DAT* dat)
{
	return dat->zip == 0 ? ftell(dat->file.fp)
	                     : unztell(dat->file.uf);
}

static int
dat_read(DAT* dat, void* buf, int len)
{
	return dat->zip == 0 ? fread(buf, 1, len, dat->file.fp)
	                     : unzReadCurrentFile(dat->file.uf, buf, len);
}

static char*
dat_gets(DAT* dat, char* string, int n)
{
	/* ʏt@C̏ꍇ... */
	if(dat->zip == 0) {
		string = fgets(string, n, dat->file.fp);

	/* ZIPt@C̏ꍇ... */
	} else {
		/* clip/clipio.cfgets()Rs[āAfread()unzReadCurrentFile()ɒu܂B */
		char* p = string;
		if(n <= 0) return NULL;
		while(--n) {
			if(unzReadCurrentFile(dat->file.uf, p, 1) != 1) {
				if(p == string) return NULL;
				break;
			}
			if(*p++ == '\n') break;
		}
		*p = '\0';
	}

	return string;
}

/* ŏɈ񂾂Ăԏ */
int
dat_init1(DAT* dat, const char* fname, int zip)
{
	int i;
	FILE* fp;
	unzFile uf;

	/* ܂mɃt@C܂B */
	dat_free(dat);

	/* SoϐNAB */
	memset(dat, 0, sizeof(DAT)); /* line_ofs[0] <- 0 ˂܂ */

	/* ʏt@CƂăI[vB */
	if(zip == 0) {
		fp = fopen(fname, "rb");
		if(fp == NULL) return -1;
		dat->file.fp = fp;
		dat->zip = 0;

	/* ZIPt@CƂăI[vB */
	} else {
		uf = unzOpen(fname);
		if(uf == NULL) return -1;
		for(i = 1/*#1x[XłI*/; i < zip; i++) {
			if(unzGoToNextFile(uf) != 0) break;
		}
		if(i < zip || unzOpenCurrentFile(uf) != 0) {
			unzClose(uf);
			return -1;
		}
		dat->file.uf = uf;
		dat->zip = zip;
	}

	return 0;
}

/* UI񂵂Ȃ珇 */
int
dat_init2(DAT* dat)
{
	/* ɊĂ牽܂B */
	if(dat->init_pos == -1) return 0;

	/* Ȏ̓ǂݍ݈ʒu𕜌܂B */
	dat_seek(dat, dat->init_pos);

	/* es̈ʒu߂܂B */
	if(dat->n_lines == MAX_LINES) { dat->init_pos = -1; return -1; } /*  */
	if(dat_gets(dat, dat->line, LINE_SIZE) == NULL) { dat->init_pos = -1; return -1; } /*  */
	dat->line_ofs[++dat->n_lines] = dat_tell(dat); /* line_ofs[i+1] <- sȉI[ItZbg */

	/* ̂߂ɓǂݍ݈ʒuۑ܂B */
	dat->init_pos = dat_tell(dat);

	return 0;
}

void
dat_free(DAT* dat)
{
	/* t@CJĂA܂B */
	if(dat->file.opened) {
		if(dat->zip == 0) {
			fclose(dat->file.fp);
		} else {
			unzClose(dat->file.uf);
		}
	}
	memset(dat, 0, sizeof(DAT)); /* Ƃ}[N */
}

static void
dat_line(DAT* dat, int i_line)
{
	int ofs, len;

	/* w肳ꂽsǂݍ݂܂B */
	if(i_line < 0 || dat->n_lines - 1 < i_line) DIE();
	ofs = dat->line_ofs[i_line];
	len = dat->line_ofs[i_line + 1] - ofs;
	dat_seek(dat, ofs);
	if(dat_read(dat, dat->line, len) != len) DIE();
	dat->line[len] = '\0'; /* dvIYȂ */

	/* ̉s폜܂B(łɑŐ󔒂) */
	trim(dat->line);

	/* |C^擪ɖ߂܂B */
	dat->pos = dat->line;
}

typedef struct _AMP {
	char code;
	const char* name;
} AMP;
static const AMP amp[] = {
	{ ' ',"nbsp"},
	{'"',"quot"},
	{'&',"amp"},
	{'<',"lt"},
	{'>',"gt"},
};

static int
dat_char(DAT* dat, int ignore_space)
{
	int i, len;
	char code;

	/* ꕶ擾B */
	do {
		code = *dat->pos++;
	} while(ignore_space && isspace(code));

	/* u</b>vAu<a href="...">vȂ */
	if(code == '<') {
		dat->tag = dat->pos;
		while((code = *dat->pos) != '>') {
			if(code == '\0') return C_ERR;
			dat->pos++;
		}
		*dat->pos++ = '\0';
		return C_TAG;
	}

	/* u&amp;vAu&lt;vȂ
	 * {̒ɒځu&v邱Ƃ̂ŁAvȂ΂̂܂܎g܂B
	 *   ɁA{ɏꂽURĹACGI&u&amp;vɂȂ炸u&v̂܂܌悤łB
	 *   {{
	 *     ftHg̖<>sage<>02/03/05 16:15<>
	 *     [ށB̂.datȂǂ߂ȂǁA<br>
	 *     http://pc.2ch.net/test/read.cgi?bbs=tech&key=/../kako/1003/10032/1003222181<br>
	 *     .dat邩ǂ߂肵āB<br>
	 *     http://mentai.2ch.net/test/read.cgi?bbs=mukashi&key=/../accuse/kako/952/952147466&raw=.0<>
	 *   }}
	 *   Ȃu&amp;vɂȂ̂AsłB
	 */
	if(code == '&') {
		for(i = 0; i < sizeof amp / sizeof *amp; i++) {
			len = strlen(amp[i].name);
			if(memcmp(dat->pos, amp[i].name, len) == 0 &&
			   dat->pos[len] == ';') {
				dat->pos += len + 1;
				return amp[i].code;
			}
		}
		/* p */
	}

	/* oCg */
	if(ismbblead(code)) {
		if(!ismbbtrail(*dat->pos)) return C_ERR;
		return (code & 0xff) << 8 | (*dat->pos++ & 0xff);
	}

	return code & 0xff;
}

/****************************************************************************
 *	mess
 ****************************************************************************/

static int
mess_init_sub(char* buff, int size, DAT* dat)
{
	int i, code;

	i = 0;
	for(;;) {
		code = dat_char(dat, 0); /* r̋󔒕͖ȂAŐ󔒂͍ŌɎ菜 */
		if(code == '\0') break; /* code='\0'ŏI */
		if(code == C_ERR) return C_ERR;
		if(code == C_TAG) {
			if(strcmp(dat->tag, "") == 0) {
				break; /* <> ... code=C_TAGŏI */
			} else {
				continue; /* ȊÕ^O͖ */
			}
		}
		if(code > 0xff) { /* 2oCg */
			if(i + 2 <= size) {
				buff[i++] = code >> 8 & 0xff;
				buff[i++] = code      & 0xff;
			} else {
				i = size; /* ̌A]v1oCgǉȂ悤 */
			}
		} else { /* 1oCg */
			if(i + 1 <= size) {
				buff[i++] = code;
			}
		}
	}
	trim(buff); /* Ő󔒂菜 */

	return code;
}

int
mess_init(MESS* mess, DAT* dat, int i_line)
{
	int col, row, code;
	/* AJ[̓tF[YF
	 * 0:AJ[O
	 * 1:">"
	 * 2:">>"
	 * 3:">>[1-9]"
	 * 4:">>[1-9][0-9]*"
	 * <a href="">URL̓XbhɂċKႤ̂ŁAURLł͂Ȃ{𒼐ډ͂܂B
	 * AJ[I^O͓ʈȂ̕ɂAJ[IƓɏ܂B
	 */
	int anchor_phase = 0;

	memset(mess, 0, sizeof(MESS));

	/* sǂݍ݁B */
	dat_line(dat, i_line);

	/* OE[E */
	if(mess_init_sub(mess->name, NAME_SIZE, dat) != C_TAG) goto ERR;
	if(mess_init_sub(mess->mail, MAIL_SIZE, dat) != C_TAG) goto ERR;
	if(mess_init_sub(mess->time, TIME_SIZE, dat) != C_TAG) goto ERR;

	/* { */
	col = 0;
	row = 0;
	for(;;) {
		code = dat_char(dat, 1); /* {̋󔒕͑SĖ */
		if(code == '\0') goto ERR;
		if(code == C_ERR) goto ERR;
		/* AJ[́B */
		switch(anchor_phase) {
		case 1:
			if(code == '>') {
				anchor_phase = 2;
			} else if(!isspace(code)) { /* u<a href="">vƁu>>123v̊Ԃ̋󔒕͋eĂ݂iȂƂȂj */
				anchor_phase = 0;
			}
			break;
		case 2:
			if(code == '>') {
				anchor_phase = 3;
			} else {
				anchor_phase = 0;
			}
			break;
		case 3:
			if('1' <= code && code <= '9') {
				mess->anchors[mess->n_anchors].mess = code - '0';
				anchor_phase = 4;
			} else {
				anchor_phase = 0;
			}
			break;
		case 4:
			if('0' <= code && code <= '9') {
				mess->anchors[mess->n_anchors].mess =
				mess->anchors[mess->n_anchors].mess * 10 + (code - '0');
				/* tF[Y4p */
			} else {
				if(1 <= mess->anchors[mess->n_anchors].mess && mess->anchors[mess->n_anchors].mess <= MAX_LINES) {
					mess->anchors[mess->n_anchors].mess--; /* bZ[Wԍ -> CfNX ϊĂ܂ */
					mess->anchors[mess->n_anchors].col2 = col;
					mess->anchors[mess->n_anchors].row2 = row;
					mess->n_anchors++; /* LȃAJ[m肵̂ŁAAJ[JEgAbv܂ */
				}
				anchor_phase = 0;
			}
			break;
		}
		/* ^OA܂́Ai[B */
		if(code == C_TAG) {
			if(strcmp(dat->tag, "") == 0) {
				break; /* <>Ŗ{I */
			} else if(strcmp(dat->tag, "br") == 0) { /* s */
				if(col > 0) { /* s͍Ȃ */
					col = 0;
					row++;
				}
			} else if(strncmp(dat->tag, "a ", 2) == 0) { /* AJ[Jn("<a "܂ňvOK) */
				if(mess->n_anchors < MAX_ANCHORS) {
					anchor_phase = 1; /* AɊJnĂAO̊Jn͖ */
					mess->anchors[mess->n_anchors].col1 = col;
					mess->anchors[mess->n_anchors].row1 = row;
					/* ܂AJ[̓JEgAbv܂BƂɃJEgAbv܂B */
				}
			} else {
				/* Ή^O */
			}
		} else if(code > 0xff) { /* 2oCg */
			if(col + 2 > TEXT_COLS) {
				col = 0;
				row++;
			}
			if(row < TEXT_ROWS) {
				mess->text[row][col++] = code >> 8 & 0xff;
				mess->text[row][col++] = code      & 0xff;
				if(col == TEXT_COLS) {
					col = 0;
					row++;
				}
			}
		} else { /* 1oCg */
			if(row < TEXT_ROWS) {
				mess->text[row][col++] = code;
				if(col == TEXT_COLS) {
					col = 0;
					row++;
				}
			}
		}
	}
	if(col > 0) {
		col = 0;
		row++;
	}
	mess->n_rows = row;

	/* ^Cg */
	if(mess_init_sub(mess->title, TITLE_SIZE, dat) != '\0') goto ERR;

	return 0;

ERR:
	memset(mess, 0, sizeof(MESS));
	/*                          01234567890123456789012345678901 */
	strncpy(&mess->text[0][0], "ĩbZ[W͉Ă܂j", TEXT_COLS);
	mess->n_rows = 1;
	return -1;
}
