#include <stdarg.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <piece.h>

#include <smcvals.h>

#include "sfont.h"

#define Font1_1(A) ((A & 0xf80000) >> 19)	//SptHgPsڑOTbit
#define Font1_2(A) ((A & 0x7c000) >> 14)	//SptHgPsڌ㔼Tbit
#define Font2_1(A) ((A & 0xf80) >> 7)		//SptHgQsڑOTbit
#define Font2_2(A) ((A & 0x7c) >> 2)		//SptHgQsڌ㔼Tbit

const unsigned long SFONT_TBL1[32] = {		//tHgϊpe[u(5bit4byte)nɍ
	0x00000000, 0x02000000, 0x00020000, 0x03020000,
	0x00020100, 0x02020100, 0x00030100, 0x03030100,
	0x00000200, 0x02000200, 0x00020200, 0x03020200,
	0x00010300, 0x02010300, 0x00030300, 0x03030300,
	0x00000002, 0x02000002, 0x00020002, 0x03020002,
	0x00020102, 0x02020102, 0x00030102, 0x03030102,
	0x00000203, 0x02000203, 0x00020203, 0x03020203,
	0x00010303, 0x02010303, 0x00030303, 0x03030303
};

const unsigned long SFONT_TBL2[32] = {		//tHgϊpe[u(5bit4byte)nɔ
	0x03030303, 0x01030303, 0x03010303, 0x00010303,
	0x03010203, 0x01010203, 0x03000203, 0x00000203,
	0x03030103, 0x01030103, 0x03010103, 0x00010103,
	0x03020003, 0x01020003, 0x03000003, 0x00000003,
	0x03030301, 0x01030301, 0x03010301, 0x00010301,
	0x03010201, 0x01010201, 0x03000201, 0x00000201,
	0x03030100, 0x01030100, 0x03010100, 0x00010100,
	0x03020000, 0x01020000, 0x03000000, 0x00000000
};

typedef struct _KFONTHDR {
	unsigned short ofs;
	unsigned char s;
	unsigned char e;
} KFONTHDR;

static const unsigned char __nofont[] = {
	0x55,0x55,0x55, 0x55,0x55,0x55, 0x55,0x55,0x55,
	0x55,0x55,0x55, 0x55,0x55,0x55, 0x55,0x55,0x55,
};

#define NOFONT ((unsigned char *)__nofont)

#define Fnt_hp 0xc0c000
#define Fnt_n 10
#define Fnt_hb Fnt_n
#define Fnt_zb (Fnt_n + (Fnt_n>>1))
#define Fnt_zp (Fnt_hp + Fnt_hb * 160)
#define Fnt_zc 84

SFONT sFontStatus = { 0,0,0,127,0,87,0 };	//8*10^CvFONT̕\ݒ




/*******************************************************************
* ֐FsFontGetAdrs 
*  WtHg̃AhX擾܂B
*-------------------------------------------------------------------
* 
*  code --- R[h
*-------------------------------------------------------------------
* ߂l
*  tHg̃AhX
*   AhXb311̏ꍇ͔ptHgł邱Ƃ܂B
*-------------------------------------------------------------------
* l
*  R[h͈ȉ͈̔͂łB
*   0x20 - 0x7f : ASCII
*   0xa0 - 0xdf : pJi
*   0x8140 - 0xfcfc : 
*******************************************************************/
static const unsigned char *sFontGetAdrs( unsigned short code )
{
	unsigned char h = code>>8;
	unsigned char l = code;
	KFONTHDR *hp;

	if ( h >= 0x81 && h <= 0x9f ) {
		h-=0x81;
	}
	else if ( h >= 0xe0 && h <= 0xfc ) {
		h-=(0x81+0x40);
	}
	else if ( h == 0 ) {	// p
		if ( l >= 0x20 && l <= 0x7f ) {
			return (unsigned char *)(0x80000000 + Fnt_hp + (l-0x20)*Fnt_hb);
		}
		else if ( l >= 0xa0 && l <= 0xdf ) {
			return (unsigned char *)(0x80000000 + Fnt_hp + (l-0x40)*Fnt_hb);
		}
		return NOFONT+0x80000000;
	}
	else {
		return NOFONT;
	}

	h<<=1;
	if ( l >= 0x80 ) l--;
	l-=0x40;
	if ( l >= 94 ) { l-=94; h++; }

	if ( h >= Fnt_zc || l >= 94 ) return NOFONT;

	hp = ((KFONTHDR *)Fnt_zp) + h;

	if ( l < hp->s || l > hp->e ) return NOFONT;

	return (unsigned char *)(Fnt_zp + sizeof(*hp)*Fnt_zc + (hp->ofs-hp->s+l)*Fnt_zb);
}


/*******************************************************************
* ֐FsFontPut 
*  p4*10,Sp8*10tHgzʂɕ\܂B
*-------------------------------------------------------------------
* 
*  x    --- W
*  y    --- cW
*  code --- R[h
*-------------------------------------------------------------------
* ߂l
*  b0-7  --- ̕
*  b8-15 --- c̕
*-------------------------------------------------------------------
* l
*  gpO sFontStatus.spr ݒ肵ĂĉB
*   sFontStatus.spr  --- FwiF
*                    0:              Ȃ
*                    1:              
*                    2:              Ȃ
*                    3:              
*  gpł镶R[h pceFontGetAdrs() B
*  zʂ͈̔͊O̓NbsO܂B
*******************************************************************/
unsigned short sFontPut( int x, int y, unsigned short code )
{
	const unsigned char *p = sFontGetAdrs( code );
	unsigned char *q = pceLCDSetBuffer(INVALIDPTR)+(y<<7);
	int ye = y + 10;
	char wkspr = sFontStatus.spr&1;				//ߐFL
	char wkcolor = (sFontStatus.spr&2)?3:0;		//ߐF
	const unsigned long *SFONT_TBL = (sFontStatus.spr&2)?SFONT_TBL2:SFONT_TBL1;//tHgϊpe[u|C^

	if ( (int)p & 0x80000000) {//p
		int xe = x + 4;
		if ( ye > 88 || y < 0 || xe > 128 || x < 0 || wkspr ) {//ʓɎ܂Ȃ y ߗL
			for ( ; y < ye; y++ ) {
				unsigned long a = *p++;
				unsigned char *b = (unsigned char *)&SFONT_TBL[a>>3];
				if ( y >= 0 && y < 88 ) {
					if (wkspr) {
						for ( ; x < xe; x++,b++ ) {
							if ( x >= 0 && x < 128 && *b != wkcolor) q[x] = *b;
						}
					}
					else {
						for ( ; x < xe; x++,b++ ) {
							if ( x >= 0 && x < 128 ) q[x] = *b;
						}
					}
					x -= 4;
				}
				q+=128;
			}
		}
		else {//ʓɎ܂鎞i߂Ȃj
			for ( ; y < ye; y++ ) {
				unsigned long a = *p++;
				memcpy( q+x, &SFONT_TBL[a>>3], 4 );
				q+=128;
			}
		}
		return (10<<8)+4;
	}
	else {//Sp
		int xe = x + 8;
		if ( ye > 88 || y < 0 || xe > 128 || x < 0 || wkspr ) {//ʓɎ܂Ȃ y ߗL
			for ( ; y < ye; y+=2 ) {
				unsigned long a = p[0]<<16 | p[1]<<8 | p[2];
				if ( y+1 >= 0 && y < 88 ) {
					int i;
					unsigned char b[8],c[8];
					memcpy( b, &SFONT_TBL[Font1_1(a)], 4 );
					memcpy( b+4, &SFONT_TBL[Font1_2(a)], 4 );
					memcpy( c, &SFONT_TBL[Font2_1(a)], 4 );
					memcpy( c+4, &SFONT_TBL[Font2_2(a)], 4 );
					if ( wkspr ) {
						for ( i = x ; i < xe ; i++ ) {
							if ( i >= 0 && i < 128 ) {
								if ( y >= 0 && b[i-x] != wkcolor ) q[i] = b[i-x];
								if ( y+1 < 88 && c[i-x] != wkcolor ) q[i+128] = c[i-x];
							}
						}
					}
					else {
						for ( i = x ; i < xe ; i++ ) {
							if ( i >= 0 && i < 128 ) {
								if ( y >= 0 ) q[i] = b[i-x];
								if ( y+1 < 88 ) q[i+128] = c[i-x];
							}
						}
					}
				}
				p+=3;
				q+=256;
			}
		}
		else {//ʓɎ܂鎞i߂Ȃj
			for ( ; y < ye; y+=2 ) {
				unsigned long a = p[0]<<16 | p[1]<<8 | p[2];
				memcpy( q+x, &SFONT_TBL[Font1_1(a)], 4 );
				memcpy( q+x+4, &SFONT_TBL[Font1_2(a)], 4 );
				memcpy( q+x+128, &SFONT_TBL[Font2_1(a)], 4 );
				memcpy( q+x+132, &SFONT_TBL[Font2_2(a)], 4 );
				p+=3;
				q+=256;
			}
		}
		return (10<<8)+8;
	}
}

/*******************************************************************
* ֐FsFontPutStr 
*  p4*10,Sp8*10tHgŕzʂɏ݂܂B
*-------------------------------------------------------------------
* 
*  *p --- ̃AhXB0 ŏI[B
*-------------------------------------------------------------------
* ߂l
*  sFontStatusŎw肳ꂽʔ͈͊O܂ŕ\iłꍇ
*   \Ȃ̃AhX
*  ȊO
*   NULL
*  Ԃ܂
*-------------------------------------------------------------------
* l
*  gpO sFontStatus ݒ肵ĉB
*   sFontStatus.x    --- \ʒuW(0)
*   sFontStatus.y    --- \ʒucW(0)
*   sFontStatus.xMin --- \͈͉ŏl(0)
*   sFontStatus.xMax --- \͈͉ől(127)
*   sFontStatus.yMin --- \͈͏cŏl(0)
*   sFontStatus.yMax --- \͈͏cől(87)
*   sFontStatus.spr  --- FwiF(0)
*                    0:              Ȃ
*                    1:              
*                    2:              Ȃ
*                    3:              
*    ()̐l̓ftHglł
*    sFontStatus.x  sFontStatus.y͂̊֐sƁA
*    ̕\ׂɎIɍXV܂B
*******************************************************************/
char *sFontPutStr( const char *p )
{
	union {
		unsigned short s;
		struct {
			unsigned char w;
			unsigned char h;
		} b;
	} m;
	unsigned char c1;
	char *rpt = NULL;
	m.s = 0;

	while ( 1 ) {
		c1 = *p++;
		if ( !c1 ) break;
		if ( (c1>=0x81 && c1<=0x9f) || (c1>=0xe0 && c1<=0xfc) ) {
			if ( *p ) {
				unsigned char c2 = *p++;
				m.s = sFontPut( sFontStatus.x, sFontStatus.y, (c1<<8) + c2 );
			}
			else {
				break;
			}
		}
		else if ( c1 == '\r' ) {
			if ( *p == '\n' ) p++;
			goto CRLF;
		}
		else if ( c1 == '\n' ) {
			goto CRLF;
		}
		else {
			m.s = sFontPut( sFontStatus.x, sFontStatus.y, c1 );
		}
		sFontStatus.x += m.b.w;
		c1 = *p;
		if ( sFontStatus.x+3+((c1>=0x81 && c1<=0x9f) || (c1>=0xe0 && c1<=0xfc))*4 > sFontStatus.xMax ) {
CRLF:
			sFontStatus.x = sFontStatus.xMin;
			sFontStatus.y += 10;
			if ( sFontStatus.y+9 > sFontStatus.yMax ) {
				sFontStatus.y = sFontStatus.yMin;
				if ( *p ) rpt = (char *)p;
				break;
			}
		}
	}
	return rpt;
}

// ȉ nsawáwԊOXMODEMx 蔲

/****************************************************************************
 *	sFontPrintf
 ****************************************************************************/

int
sFontPrintf(const char* fmt, ...)
{
extern unsigned char _def_vbuff[]; /* WJɗp */
	int result;
	va_list ap;

	va_start(ap, fmt);
	result = vsprintf(_def_vbuff, fmt, ap);
	va_end(ap);

	sFontPutStr(_def_vbuff);

	return result;
}

